function getElementAtLine(line) {
  const elements = document.querySelectorAll('[begin-line]');
  for (let i = 0; i < elements.length; i++) {
    const beginLine = parseInt(elements[i].getAttribute('begin-line'));
    const endLine = parseInt(elements[i].getAttribute('end-line'));
    if (beginLine <= line && endLine >= line) {
      return elements[i];
    }
  }
}
function scrollToLine(line) {
  let targetOffsetY = 0;
  if (line > 1) {
    targetOffsetY = getElementAtLine(line).getBoundingClientRect().top + window.pageYOffset;
  }
  window.scrollTo({top: targetOffsetY, behavior: 'instant'});
}
function getLineOfFirstVisibleElement() {
  const elements = document.querySelectorAll('[begin-line]');
  for (let i = 0; i < elements.length; i++) {
    const element = elements[i];
    const rect = element.getBoundingClientRect();
    if (rect.bottom >= 0 && rect.top <= window.innerHeight) {
      return parseInt(element.getAttribute('begin-line'));
    }
  }
}
function saveScrollPosition() {
  sessionStorage.setItem('scrollPosition', window.scrollY);
}
function restoreScrollPosition() {
  let scrollPosition = sessionStorage.getItem('scrollPosition');
  if (scrollPosition !== null) {
    window.scrollTo(0, parseInt(scrollPosition));
  }
}

window.addEventListener('load', restoreScrollPosition);
window.addEventListener('beforeunload', saveScrollPosition);

window.addEventListener("scroll", function() {
  window.webkit.messageHandlers.onScroll.postMessage(null);
});
